/*
 * blink_sub.c
 *
 *  Created on: 2021/03/23
 *      Author: 0170886
 */

#include <kernel.h>
#include "kernel_cfg.h"
#include <t_syslog.h>
#include <t_stdlib.h>

#include "device.h"
#include "cup_timer.h"
#include "common.h"
#include "blink.h"

/*
 *  Glboal Variable
 */
extern TBL_CTL		gbl_ctl;

/*
 *  LED4 Blink Task
 */
void
StIdleEvTimeOut(void){
	GBL_NEXTSTS = ST_BLINK_LED_OFF;
	GBL_CTLF |= DBL_STSCHG;		/* 状態遷移有りを設定			 	*/

	GBL_BCOUNT = TIMEOUT_BLINK;
	sta_cyc(LED4_BLINK_TIME_HANDLER);
}

void
StIdleEvAvtive(void){
	GBL_NEXTSTS = ST_BLINK_LED_OFF;
	GBL_CTLF |= DBL_STSCHG;		/* 状態遷移有りを設定			 	*/

	GBL_BCOUNT = ACT_BLINK_TIME;
	sta_cyc(LED4_BLINK_TIME_HANDLER);
}

void
StLedOffEvOff(void){
	set_led4_state(OFF);
	GBL_NEXTSTS = ST_BLINK_IDLE;
	GBL_CTLF |= DBL_STSCHG;		/* 状態遷移有りを設定			 	*/

	GBL_BCOUNT = 0;
	stp_cyc(LED4_BLINK_TIME_HANDLER);
}

void
StLedOnEvOff(void){
	set_led4_state(OFF);
	GBL_NEXTSTS = ST_BLINK_IDLE;
	GBL_CTLF |= DBL_STSCHG;		/* 状態遷移有りを設定			 	*/

	GBL_BCOUNT = 0;
	stp_cyc(LED4_BLINK_TIME_HANDLER);
}

void
StLedOffEvBlink(void){
	GBL_BCOUNT--;
	if(GBL_BCOUNT == 0){
		GBL_NEXTSTS = ST_BLINK_IDLE;
		stp_cyc(LED4_BLINK_TIME_HANDLER);
	} else {
		set_led4_state(ON);
		GBL_NEXTSTS = ST_BLINK_LED_ON;
	}
	GBL_CTLF |= DBL_STSCHG;		/* 状態遷移有りを設定			 	*/
}

void
StLedOnEvBlink(void){
	set_led4_state(OFF);
	GBL_BCOUNT--;
	if(GBL_BCOUNT == 0){
		GBL_NEXTSTS = ST_BLINK_IDLE;
		stp_cyc(LED4_BLINK_TIME_HANDLER);
	} else {
		GBL_NEXTSTS = ST_BLINK_LED_OFF;
	}
	GBL_CTLF |= DBL_STSCHG;		/* 状態遷移有りを設定			 	*/
}

