from xml.etree import ElementTree
import codecs
import csv
import glob


def main():
    objs = []
    for path in glob.glob("*.xml"):
        objs.append(ElementTree.parse(path).getroot())
    
    with codecs.open('csv/0_Total Result.csv', 'w', 'utf-8') as file:
        res = csv.writer(file, delimiter=',', lineterminator='\r\n', quotechar='"')
    
        res.writerow(["test name", "test case count", "failue count", "error count", "execute time[ms]"])
        
        
        for obj in objs:
            for val in obj.iter('testsuite'):
                res.writerow([val.get('name'), val.get('tests'), val.get('failures'), val.get('errors'), val.get('time')])
                
                with codecs.open((f'csv\{val.get("name")}.csv'), 'w', 'utf-8') as file:
                    writer = csv.writer(file, delimiter=',', lineterminator='\r\n', quotechar='"')
                    writer.writerow(["test case", "test status", "failure count", "execute time[ms]"])
                    for v in val.iter('testcase'):
                        writer.writerow([v.get("name"), v.get("status"), len(list(v.iter('failure'))), v.get("time")])
            

if __name__ == "__main__":
    print(glob.glob("*.xml"))
    main()
